<template>
  <div class="chart">
    <div class="chart__content" v-show="total > 0 && total <= 1">
      <div class="tooltip" ref="tooltip" v-if="activeEl">
        {{ activeEl.label }}
        <div class="tooltip__value">
          <b>{{ activeEl.weight }}</b>
        </div>
      </div>
      <svg width="100" height="100" viewBox="0 0 100 100" preserveAspectRatio="xMidYMin slice">
        <defs>
          <pattern
            id="stripes"
            viewBox="0,0,2,2"
            width="4"
            height="4"
            patternUnits="userSpaceOnUse"
          >
            <polygon points="0,0 1,0 0,1" fill="transparent" />
            <polygon points="0,2 2,0 2,1 1,2" fill="transparent" />
            <polygon points="0,1 0,2 2,0 1,0" fill="black" />
            <polygon points="1,2 2,2 2,1" fill="black" />
          </pattern>
        </defs>
        <circle cx="50" cy="50" r="50" :fill="background" />
        <path
          v-for="(path, index) in paths"
          :key="index"
          :d="drawPath(path.weight)"
          :fill="path.color || chartColors[index]"
          :transform="`rotate(${path.start * 3.6} 50 50)`"
          @mouseover="onMouseOver(index)"
          @mousemove="onMouseMove"
          @mouseleave="onMouseLeave(index)"
        />
        <circle cx="50" cy="50" r="30" :fill="center" />
        <text y="50">
          <tspan x="50%" text-anchor="middle"> СУММА </tspan>
          <tspan x="50%" dy="7" text-anchor="middle" font-weight="bold">{{total.toFixed(3)}}</tspan>
        </text>
      </svg>
    </div>
    <div class="no-data" v-if="total === 0 || total > 1">Нет данных или неверные данные</div>
  </div>
</template>

<script>
/* eslint-disable */
export default {
  name: "donut-chart",

  props: {
    chartData: {
      type: Array,
      required: true
    },

    chartColors: {
      type: Array,
      default: function() {
        return ["#F4F4F5", "#D1D2D6", "#9DA0AC", "#737682", "#474B5B"];
      }
    }
  },

  data() {
    return {
      mouseOver: false,
      activeEl: null,
      background: 'white',
      center: 'white',
    };
  },

  computed: {
    total() {
      return this.chartData.reduce((acc, item) => {
        return acc + item.weight;
      }, 0);
    },

    paths() {
      const res = this.chartData.reduce(
        (acc, segment) => {
          acc.segments.push({ ...segment, weight: segment.weight * 100, start: acc.start });
          acc.start += segment.weight * 100;
          return acc;
        },
        { segments: [], start: 0 }
      );

      return res.segments;
    }
  },
  methods: {
    drawPath(weight) {
      var start = 0;
      const size = "100",
        rad = size / 2,
        unit = (Math.PI * 2) / 100,
        end = weight * unit - 0.001,
        x1 = rad + rad * Math.sin(start),
        y1 = rad - rad * Math.cos(start),
        x2 = rad + rad * Math.sin(end),
        y2 = rad - rad * Math.cos(end),
        big = end - start > Math.PI ? 1 : 0;
      return `M ${rad},${rad} L ${x1},${y1} A ${rad},${rad} 0 ${big} 1 ${x2},${y2} Z`;
    },

    onMouseOver(index) {
      this.mouseOver = true;
      this.activeEl = this.chartData[index];
      this.$emit('mouseOverChart', this.activeEl);
    },

    onMouseMove($event) {
      if (this.mouseOver) {
        const tooltip = this.$refs.tooltip;
        const width = tooltip.getBoundingClientRect().width;
        const height = tooltip.getBoundingClientRect().height;
        tooltip.style.left = `${$event.pageX - (width - 17)}px`;
        tooltip.style.top = `${$event.pageY - (height + 8)}px`;
      }
    },

    onMouseLeave(index) {
      this.$emit('mouseLeaveChart', this.activeEl)
      this.mouseOver = false
      this.activeEl = null;
    }
  }
};
</script>

<style lang="scss" scoped>

.chart {
  display: flex;
  justify-content: center;
  align-items: center;
  width: 100%;
  min-width: 300px;
  padding-bottom: 100%;
  position: relative;
}

svg {
	  width: 300px;
	  height: 300px;
    position: absolute;
    top: 0;
    left: 50%;
    transform: translateX(-50%);
    font-size: 0.3em;
}

.tooltip {
  position: fixed;
  height: auto;
  padding: 8px 12px;
  background-color: white;
  border-radius: 2px;
  box-shadow: 0px 0px 8px rgba($color-text-base, 0.24);
  pointer-events: none;
  z-index: 10;
  font-size: 12px;

  &:after {
    content: "";
    width: 0;
    height: 0;
    border-style: solid;
    border-width: 4px 4px 0 4px;
    border-color: $risksPages-DonutChart-tooltip_border-color_after transparent transparent transparent;
    position: absolute;
    top: 100%;
    right: 15px;
  }
}

.tooltip__value {
  font-weight: 700;
}

path:hover {
  fill: url(#stripes) !important;
}

.no-data {
  position: absolute;
  left: 50%;
  top: 50%;
  transform: translate(-50%, -50%);
}
</style>